#include <bits/stdc++.h>

using namespace std;
#define int long long

// *.local, 169.254/16 proxy

struct point {
    int x, y;

    point() : x(0), y(0) {};

    point(int _x, int _y) : x(_x), y(_y) {};

    point operator+(point a) {
        return {x + a.x, y + a.y};
    }

    void scan() {
        cin >> x >> y;
    }
};

struct line {
    int a, b, c, x1, y1, x2, y2;

    line() : x1(0), y1(0), x2(0), y2(0), a(0), b(0), c(0) {};

    line(int _a, int _b, int _c, int _x1, int _y1, int _x2, int _y2) : a(_a), b(_b), c(_c), x1(_x1), y1(_y1), x2(_x2),
                                                                       y2(_y2) {};

    void scan() {
        cin >> a >> b >> c;
    }
};

line create(point a, point b) {
    return line(b.y - a.y, a.x - b.x, -(a.x * b.y - b.x * a.y), a.x, a.y, b.x, b.y);
}


point norm(line l) {
    return point(l.a, l.b);
}

line move(point x, line l) {
    point v = point(-l.b, l.a);
    return create(x, x + v);
}

long double dist(point x, line l) {
    return abs(x.x * l.a + x.y * l.b + l.c) / sqrt(l.a * l.a + l.b * l.b);
}

long double len(point a, point b, line x, line y) {
    line l1 = move(a, x), l2 = move(b, y);
    return dist(b, l1) + dist(a, l2);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    long double dp[(1 << n)][n], ans = 1e18;
    point p[n];
    for (int i = 0; i < n; i++) p[i].scan();
    for (int ii = 0; ii < n; ii++) {
        for (int jj = ii + 1; jj < n; jj++) {
            line l1 = create(p[ii], p[jj]);
            for (int k = 2; k < n; k++) {
                line l2 = create(p[k], p[k] + norm(l1));
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < (1 << n); j++)
                        dp[j][i] = 1e18;
                }
                for (int i = 0; i < n; i++) dp[0][i] = 0;
                for (int bit = 0; bit < n; bit++) dp[(1 << bit)][bit] = 0;
                for (int mask = 1; mask < (1 << n); mask++) {
                    for (int bit = 0; bit < n; bit++) {
                        if (((mask >> bit) & 1) == 0) continue;
                        int submask = mask - (1 << bit);
                        for (int j = 0; j < n; j++) {
                            if (((submask >> j) & 1) == 0) continue;
                            dp[mask][bit] = min(dp[mask][bit], dp[submask][j] + len(p[j], p[bit], l1, l2));
                        }
                    }
                }
                long double res = 1e18;
                for (int i = 0; i < n; i++) res = min(res, dp[(1 << n) - 1][i]);
                ans = min(ans, res);
            }
        }
    }
    cout << fixed << setprecision(20) << ans;
    return 0;
}